<?php
class upyun{
	const END_POINT = "http://v0.api.upyun.com";
	private $bucketname;
        private $username;
        private $password;
	private $ctimeout;

	public function __construct($bucketname, $username, $password, $ctimeout){

		$this->bucketname = $bucketname;
                $this->username = $username;
                $this->password = $password;
                $this->ctimeout = $ctimeout;

	}

	public function getdir($getpath){

		$uri = "/{$this->bucketname}$getpath";
		$date = gmdate('D, d M Y H:i:s \G\M\T');
		//$fsize = filesize($localpath);
		$signature = base64_encode(hash_hmac("sha1", "GET&$uri&$date", md5("{$this->password}"), true));
		$header = array("Authorization:UPYUN {$this->username}:$signature", "Date:$date");

		//$fh = fopen($localpath,'rb');
		$ch = curl_init(self::END_POINT.$uri);
		//curl_setopt($ch, CURLOPT_INFILE, $fh);
		//curl_setopt($ch, CURLOPT_INFILESIZE, $fsize);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($ch, CURLOPT_TIMEOUT, "{$this->ctimeout}");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
		curl_exec($ch);
		$rsp_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		echo $rsp_code;

	}

}

$upyun = new upyun("bucket", "username", "password", 3600);
$upyun->getdir("/dir");

?>
